<template>
    <div id="markdown-view" class="markdown-view-container" ref="viewContainerRef">
        <v-progress-linear
            v-if="total > 0"
            striped
            height="5"
            :value="progress"
            :stream="true"
            class="full-width"
            :color="progressColor"
        ></v-progress-linear>
        <div class="markdown-view" :class="computeClass"/>
    </div>
</template>

<script lang='ts'>
import { defineComponent, onMounted, watch, Ref, ref, computed } from '@vue/composition-api';
import { sassRender } from "@/ipc/sassRender";
import { openExternal } from "@/ipc";
import { useAttachments, useMarkdownRenderer, useObservers } from "@/compositions";

export default defineComponent({
    name: 'MarkdownView',
    props: {
        rawText: {
            type: String,
            default: ''
        },
        fullWidth: {
            type: Boolean,
            default: false
        }
    },
    setup(props) {
        const total: Ref<number> = ref(0);
        const completed: Ref<number> = ref(0);
        const progress = computed(() => completed.value * 100 / total.value);

        const progressColor = computed(() => {
            if (progress.value < 34) return 'error';
            if (progress.value < 75) return 'warning';
            if (progress.value >= 75) return 'success';
        });

        const { viewContainerRef, convertRawText } = useMarkdownRenderer();
        const computeClass = computed(() => {
            if (props.fullWidth) return 'full-width'
            else return ''
        });

        /**
         * Loads styles from custom-defined template and applies styles.
         * @todo Prevent loading if no new styles are available.
         */
        const applyStyles = async () => {
            if (!viewContainerRef.value) return;

            const currentStyles = document.querySelector('.omm-template');

            currentStyles && viewContainerRef.value.removeChild(currentStyles);

            const css = await sassRender();

            if (!css) return;

            const styles = document.createElement('style');

            styles.innerHTML = css;
            styles.className = 'omm-template';

            viewContainerRef.value.append(styles);
        }

        /**
         * Opens links in external app.
         * @param {MouseEvent} e
         */
        const handleAnchorClick = (e: MouseEvent) => {
            if (!e || !e.target) return;

            const target = e.target as HTMLAnchorElement;

            const url = target.href;

            openExternal(url);
        }

        /**
         * Adds a click event listener on all anchor elements.
         * @param {HTMLElement} target
         */
        const anchorsRender = (target: HTMLElement) => {
            const anchors = target.querySelectorAll('a');
            const addAnchorEvent = (e: MouseEvent) => {
              e.preventDefault();
              handleAnchorClick(e);
            }

            if (!anchors || !anchors.length) return;

            anchors.forEach((anchor) => {
                anchor.removeEventListener('click', addAnchorEvent);
                anchor.addEventListener('click', addAnchorEvent);
            });
        }

        /**
         * When a checkbox receives a click update the raw text.
         * @param {MouseEvent} e
         * @param {number} index
         */
        const handleCheckBoxClick = (e: MouseEvent, index: number) => {
            const target = e.target as HTMLInputElement;
            const checked = target.checked;

            const search = /- \[[x| ]\]/gi;
            const replace = checked ? '- [X]' : '- [ ]';

            let count = -1;

            const newMarkdown = props.rawText.replace(search, (match) => {

                count++;
                return (count === index) ? replace : match;
            });

            useObservers().notifyObservers('updateRawText', { rawText: newMarkdown });
        }

        const addCheckMarks = (checkboxes: NodeListOf<Element>) => {
            let countChecked = 0;

            checkboxes.forEach((element, index) => {
                const checkbox = element as HTMLInputElement;

                countChecked += checkbox.checked ? 1 : 0;
                checkbox && checkbox.removeEventListener('click', () => handleCheckBoxClick);
                checkbox && checkbox.addEventListener('click', (e) => handleCheckBoxClick(e, index));
            });

            completed.value = countChecked;
        }

        const renderCheckBoxes = (target: HTMLElement) => {
            const uls = target.querySelectorAll('ul');
            const checkboxes = target.querySelectorAll('input[type=checkbox]');

            uls.forEach(ul => {
                const checkboxes = ul.querySelector('input[type=checkbox]');
                if (checkboxes) ul.classList.add('omm-task-list');
            });

            if (!checkboxes.length) {
                total.value = 0;
                return;
            }

            total.value = checkboxes.length;

            addCheckMarks(checkboxes);
        }

        const updateMarkdownView = async  () => {
            const rawText = await useAttachments().replaceAttachmentStrings(props.rawText);
            await convertRawText(rawText);

            if (!viewContainerRef.value) return;

            const markdownView = viewContainerRef.value.querySelector('.markdown-view') as HTMLElement;

            markdownView && anchorsRender(markdownView);
            viewContainerRef.value && renderCheckBoxes(viewContainerRef.value)
        }

        onMounted(async () => {
            await updateMarkdownView();
            await applyStyles();
        });

        watch(() => props.rawText, () => {
            updateMarkdownView()
        });

        return {computeClass, viewContainerRef, total, progress, progressColor}
    }
})
</script>

<style scoped lang="scss">
.markdown-view-container {
    display: flex;
    flex: 1;
    position: relative;

    .markdown-view {
        max-height: 100%;
        position: absolute;
        top: 0;
        left: 0;
        overflow: auto;
        padding: 20px;
        width: 100%;

        &.full-width {
            width: 100%;
        }
    }
}
</style>